﻿using System.Collections.Generic;

namespace HREngine.Bots
{
    public class BehaviorOverloadShaman : Behavior
    {
        public override string BehaviorName() { return "OverloadShaman"; }

		
        PenalityManager penman = PenalityManager.Instance;        
        int aggroborder = 19;
		
        public override float getPlayfieldValue(Playfield p)
        {
            if (p.value >= -2000000) return p.value;
            int retval = 0;
            bool coinInHand = false;
            bool doomhammerInHand = false;
            bool flamewreathedfacelessInHand = false;
            bool flametonguetotemInHand = false;

            switch (p.gTurn)
            {
                case 1:
                    foreach (Handmanager.Handcard hc in p.owncards)
                    {
                        switch (hc.card.name)
                        {
                            case CardDB.cardName.flametonguetotem: flametonguetotemInHand = true; continue;
                        }
                    }
                    if (p.ownMinions.Count > 1)
                    {
                        retval += 5;
                        if (flametonguetotemInHand) retval += 100;
                    }
                    break;
                case 2:
                    foreach (Handmanager.Handcard hc in p.owncards)
                    {
                        switch (hc.card.name)
                        {
                            case CardDB.cardName.thecoin: coinInHand = true; continue;
                            case CardDB.cardName.flamewreathedfaceless: flamewreathedfacelessInHand = true; continue;
                        }
                    }
                    if (p.ueberladung > 0)
                    {
                        if (coinInHand && flamewreathedfacelessInHand) p.evaluatePenality += 500;
                    }
                    break;
                case 3:
                    if (p.complete)
                    {
                        foreach (Handmanager.Handcard hc in p.owncards)
                        {
                            switch (hc.card.name)
                            {
                                case CardDB.cardName.thecoin: coinInHand = true; continue;
                                case CardDB.cardName.doomhammer: doomhammerInHand = true; continue;
                            }
                        }
                        if (p.ueberladung > 0)
                        {
                            if (coinInHand && doomhammerInHand && p.ownWeaponCard.name != CardDB.cardName.doomhammer) p.evaluatePenality += 500;
                        }
                    }
                    break;
                case 4:
                    if (p.complete)
                    {
                        foreach (Handmanager.Handcard hc in p.owncards)
                        {
                            switch (hc.card.name)
                            {
                                case CardDB.cardName.doomhammer: doomhammerInHand = true; continue;
                            }
                        }
                        if (p.ueberladung > 0)
                        {
                            if (doomhammerInHand && p.ownWeaponCard.name != CardDB.cardName.doomhammer) p.evaluatePenality += 500;
                        }
                    }
                    break;

            }

            int hpboarder = 10;
            if (p.ownHeroName == HeroEnum.warlock && p.enemyHeroName != HeroEnum.mage) hpboarder = 6;

            retval -= p.evaluatePenality;
            retval += p.owncards.Count * 5;

            retval += p.ownMaxMana;
            retval -= p.enemyMaxMana;

            retval += p.ownMaxMana * 20 - p.enemyMaxMana * 20;
            retval += (p.enemyHeroAblility.manacost - p.ownHeroAblility.manacost) * 4;
            if (p.ownHeroPowerAllowedQuantity != p.enemyHeroPowerAllowedQuantity)
            {
                if(p.ownHeroPowerAllowedQuantity > p.enemyHeroPowerAllowedQuantity) retval += 3;
                else retval -= 3;
            }

            if (p.enemyHeroName == HeroEnum.mage || p.enemyHeroName == HeroEnum.druid) retval -= 2 * p.enemyspellpower;

            if (p.ownHero.Hp + p.ownHero.armor > hpboarder)
            {
                retval += p.ownHero.Hp + p.ownHero.armor;
            }
            else
            {
                retval -= 2 * (hpboarder + 1 - p.ownHero.Hp - p.ownHero.armor) * (hpboarder + 1 - p.ownHero.Hp - p.ownHero.armor);
            }

            if (p.enemyHero.Hp + p.enemyHero.armor > aggroborder)
            {
                retval += 1 * (-p.enemyHero.Hp - p.enemyHero.armor);
            }
            else
            {
                retval += 4 * (aggroborder + 1 - p.enemyHero.Hp - p.enemyHero.armor);
            }

            if (p.ownWeaponAttack >= 1)
            {
                retval += p.ownWeaponAttack * p.ownWeaponDurability;
            }

            if (!p.enemyHero.frozen)
            {
                retval -= p.enemyWeaponDurability * p.enemyWeaponAttack;
            }
            else
            {
                if (p.enemyWeaponDurability >= 1)
                {
                    retval += 12;
                }
            }

            if (Ai.Instance.lethalMissing <= 5)
            {
                retval += p.owncarddraw * 100;
            }
            if (p.ownMaxMana < 4)
            {
                retval += p.owncarddraw * 2;
            }
            else
            {
                retval += p.owncarddraw * 5;
            }

            retval -= p.enemycarddraw * 15;

            int readycount = 0;
            int ownMinionsCount = 0;
            foreach (Minion m in p.ownMinions)
            {
                retval += 5;
                retval += m.Hp * 2;
                retval += m.Angr * 2;
                retval += m.handcard.card.rarity;
                if (!m.playedThisTurn && m.windfury) retval += m.Angr;
                if (m.divineshild)
                {
                    retval += 1;
                    if (flametonguetotemInHand) retval += 2;
                }
                if (m.stealth) retval += 1;
                if (m.handcard.card.isSpecialMinion && !m.silenced)
                {
                    retval += 1;
                    if (!m.taunt && m.stealth) retval += 20;
                }
                else
                {
                    if (m.Angr <= 2 && m.Hp <= 2 && !m.divineshild) retval -= 5;
                }
                if (m.divineshild && m.taunt) retval += 4;
                if (p.ownMinions.Count > 1 && (m.handcard.card.name == CardDB.cardName.direwolfalpha || m.handcard.card.name == CardDB.cardName.flametonguetotem || m.handcard.card.name == CardDB.cardName.stormwindchampion || m.handcard.card.name == CardDB.cardName.raidleader || m.handcard.card.name == CardDB.cardName.fallenhero)) retval += 10;
                if (m.handcard.card.name == CardDB.cardName.bloodmagethalnos) retval += 10;
                if (m.handcard.card.name == CardDB.cardName.nerubianegg)
                {
                    if (m.Angr >= 1) retval += 2;
                    if ((!m.taunt && m.Angr == 0) && (m.divineshild || m.maxHp > 2)) retval -= 10;
                }
                if (m.Ready) readycount++;
                if (m.Hp <= 4 && (m.Angr > 2 || m.Hp > 3)) ownMinionsCount++;
                retval += m.synergy;
            }
			
            bool useAbili = false;
            int usecoin = 0;
            int deletecardsAtLast = 0;
            foreach (Action a in p.playactions)
            {
                if (a.actionType == actionEnum.attackWithHero && p.enemyHero.Hp <= p.attackFaceHP) retval++;
                if (a.actionType == actionEnum.useHeroPower) useAbili = true;
                if (p.ownHeroName == HeroEnum.warrior && a.actionType == actionEnum.attackWithHero && useAbili) retval -= 1;
                if (a.actionType != actionEnum.playcard) continue;
                if (a.card.card.name == CardDB.cardName.thecoin) usecoin++;
                if (a.card.card.name == CardDB.cardName.innervate) usecoin += 2;
				
                if (a.card.card.name == CardDB.cardName.soulfire || a.card.card.name == CardDB.cardName.doomguard || a.card.card.name == CardDB.cardName.succubus) deletecardsAtLast = 1;
                if (deletecardsAtLast == 1 && !(a.card.card.name == CardDB.cardName.soulfire || a.card.card.name == CardDB.cardName.doomguard || a.card.card.name == CardDB.cardName.succubus)) retval -= 20;
                if (a.target == null) continue;
                if (p.ownHeroName != HeroEnum.thief && a.card.card.type == CardDB.cardtype.SPELL && (!a.target.own && a.target.isHero) && a.card.card.name != CardDB.cardName.shieldblock) retval -= 11;
                if (p.ownHeroName == HeroEnum.thief && a.card.card.type == CardDB.cardtype.SPELL && (a.target.isHero && !a.target.own)) retval -= 11;
            }
            if (usecoin > 0)
            {
                if (useAbili && p.ownMaxMana <= 2) retval -= 40;
                retval -= 5 * p.manaTurnEnd;
                if (p.manaTurnEnd + usecoin > 10) retval -= 5 * usecoin;
            }
            if (p.manaTurnEnd >= 2 && !useAbili && p.ownAbilityReady)
            {
                switch (p.ownHeroAblility.card.name)
                {
                    case CardDB.cardName.heal: goto case CardDB.cardName.lesserheal;
                    case CardDB.cardName.lesserheal:
                        bool wereTarget = false;
                        if (p.ownHero.Hp < p.ownHero.maxHp) wereTarget = true;
                        if (!wereTarget)
                        {
                            foreach (Minion m in p.ownMinions)
                            {
                                if (m.wounded) { wereTarget = true; break; }
                            }
                        }
                        if (wereTarget && !(p.anzOwnAuchenaiSoulpriest > 0 || p.embracetheshadow > 0)) retval -= 10;
                        break;
                    case CardDB.cardName.poisoneddaggers: goto case CardDB.cardName.daggermastery;
                    case CardDB.cardName.daggermastery:
                        if (!(p.ownWeaponDurability > 1 || p.ownWeaponAttack > 1)) retval -= 10;
                        break;
                    case CardDB.cardName.totemicslam: goto case CardDB.cardName.totemiccall;
                    case CardDB.cardName.totemiccall:
                        if (p.ownMinions.Count < 7) retval -= 10;
                        else retval -= 3;
                        break;
                    case CardDB.cardName.thetidalhand: goto case CardDB.cardName.reinforce;
                    case CardDB.cardName.thesilverhand: goto case CardDB.cardName.reinforce;
                    case CardDB.cardName.reinforce:
                        if (p.ownMinions.Count < 7) retval -= 10;
                        else retval -= 3;
                        break;
                    case CardDB.cardName.soultap:
                        if (p.owncards.Count < 10 && p.ownDeckSize > 0) retval -= 10;
                        break;
                    case CardDB.cardName.lifetap:
                        if (p.owncards.Count < 10 && p.ownDeckSize > 0)
                        {
                            retval -= 10;
                            if (p.ownHero.immune) retval -= 5;
                        }
                        break;
                    default:
                        retval -= 10;
                        break;
                }
            }

            int mobsInHand = 0;
            int bigMobsInHand = 0;
            foreach (Handmanager.Handcard hc in p.owncards)
            {
                if (hc.card.type == CardDB.cardtype.MOB)
                {
                    mobsInHand++;
                    if (hc.card.Attack >= 3) bigMobsInHand++;
                }
            }

            if (ownMinionsCount - p.enemyMinions.Count >= 4 && bigMobsInHand >= 1)
            {
                retval += bigMobsInHand * 25;
            }

            foreach (Minion m in p.enemyMinions)
            {
                retval -= this.getEnemyMinionValue(m, p);
            }
            retval -= p.enemySecretCount;
            retval -= p.lostDamage;
            retval -= p.lostWeaponDamage;

            if (p.enemyHero.Hp <= 0)
            {
                retval += 10000;
                if (retval < 10000) retval = 10000;
            }

            if (p.enemyHero.Hp >= 1 && p.guessingHeroHP <= 0)
            {
                if (p.turnCounter < 2) retval += p.owncarddraw * 100;
                retval -= 1000;
            }
            if (p.ownHero.Hp <= 0) retval -= 10000;

            p.value = retval;
            return retval;
        }

        public override int getEnemyMinionValue(Minion m, Playfield p)
        {
            int retval = 5;
            if (m.frozen && !(m.name == CardDB.cardName.ragnarosthefirelord && !m.silenced)) retval = 0;
            else if (!(m.name == CardDB.cardName.ancientwatcher && !m.silenced))
            {
                retval += m.Hp + m.Angr;
                if (m.windfury) retval += m.Angr;
            }
			
            if (!m.handcard.card.isSpecialMinion)
            {
                if (m.Angr == 0) retval -= 7;
                else if (m.Angr <= 2 && m.Hp <= 2 && !m.divineshild) retval -= 5;
            }
			
            if (m.taunt) retval += 5;
            if (m.poisonous) retval += 4;
			
            if (m.handcard.card.targetPriority >= 1 && !m.silenced)
            {
                retval += m.handcard.card.targetPriority;
            }
            retval += m.synergy;
            return retval;
        }

        public override int getPlayCardPenality(CardDB.Card card, Minion target, Playfield p, bool lethal)
        {
            int pen = 0;
            switch (card.name)
            {
                case CardDB.cardName.doomhammer:
                    if (p.gTurn < 6) pen -= 6000;
                    break;
                case CardDB.cardName.flamewreathedfaceless:
                    if (p.ownWeaponCard.name == CardDB.cardName.doomhammer && (p.gTurn == 5 || p.gTurn == 6)) pen -= 1000;
                    break;
                case CardDB.cardName.rockbiterweapon:
                    if (p.gTurn > 6 || lethal)
                    {
                        if (target.own && target.Ready && !target.frozen && p.anzEnemyTaunt < 1)
                        {
                            if (target.isHero && p.ownWeaponCard.name == CardDB.cardName.doomhammer) pen -= 1000;
                            else if (target.windfury && !target.silenced && target.numAttacksThisTurn == 0) pen -= 500;
                            else if (lethal && p.enemyHero.Hp + p.enemyHero.armor <= aggroborder) pen -= 200;
                        }
                    }
                    else if (p.gTurn < 3 && target.name == CardDB.cardName.tunneltrogg) break;
                    else pen += 500;
                    break;
                case CardDB.cardName.lavaburst:
                    if (p.gTurn < 4)
                    {
                        bool omOnBoard = false;
                        foreach (Minion m in p.ownMinions)
                        {
                            if (m.name == CardDB.cardName.tunneltrogg || m.name == CardDB.cardName.unboundelemental)
                            {
                                omOnBoard = true;
                                break;
                            }
                        }
                        bool found = false;
                        int dmg = p.getSpellDamageDamage(5);
                        foreach (Minion m in p.enemyMinions)
                        {
                            if (m.Hp >= dmg - 1 && m.Angr > 1)
                            {
                                if (omOnBoard) pen += 2 * m.Angr;
                                else pen += 4 * m.Angr;
                                found = true;
                                break;
                            }
                        }
                        if (!found) pen += 500;
                    }
                    break;
                case CardDB.cardName.lightningbolt:
                    if (p.gTurn < 4) pen += 7;
                    if (!lethal && target.entitiyID == p.enemyHero.entitiyID && p.enemyHero.Hp + p.enemyHero.armor > aggroborder)
                    {
                         int dmg = p.getSpellDamageDamage(3);
                         foreach (Minion m in p.enemyMinions)
                         {
                             if (m.Hp == dmg)
                             {
                                 pen += 2 * m.Angr;
                                 break;
                             }
                         }
                    }
                    break;
            }
            return pen;
        }

        public override int getSirFinleyPriority(List<Handmanager.Handcard> discoverCards)
        {
            int sirFinleyChoice = -1;
            int tmp = int.MinValue;
            for (int i = 0; i < discoverCards.Count; i++)
            {
                CardDB.cardName name = discoverCards[i].card.name;
                if (SirFinleyPriorityList.ContainsKey(name) && SirFinleyPriorityList[name] > tmp)
                {
                    tmp = SirFinleyPriorityList[name];
                    sirFinleyChoice = i;
                }
            }
            return sirFinleyChoice;
        }

        private Dictionary<CardDB.cardName, int> SirFinleyPriorityList = new Dictionary<CardDB.cardName, int>
        {
            { CardDB.cardName.lesserheal, 3 }, //HeroPowerName, Priority (0-9)
            { CardDB.cardName.shapeshift, 6 },
            { CardDB.cardName.fireblast, 7 },
            { CardDB.cardName.totemiccall, 1 },
            { CardDB.cardName.lifetap, 9 },
            { CardDB.cardName.daggermastery, 5 },
            { CardDB.cardName.reinforce, 4 },
            { CardDB.cardName.armorup, 2 },
            { CardDB.cardName.steadyshot, 8 }
        };

        public override int getAttackWithHeroPenality(Minion target, Playfield p, bool lethal)
        {
            int pen = 0;
            if (target.isHero && p.enemyHero.Hp + p.enemyHero.armor > aggroborder && p.ownWeaponAttack < 4)
            {
                int numAttacks = 1 + (p.ownWeaponCard.windfury ? 1 : 0) - p.ownHero.numAttacksThisTurn;
                if (p.ownWeaponDurability < numAttacks) numAttacks = p.ownWeaponDurability;

                foreach (Minion m in p.enemyMinions)
                {
                    if (m.Hp <= p.ownWeaponAttack)
                    {
                        pen += m.Angr + m.Hp;
                        numAttacks--;
                        if (numAttacks < 1) break;
                    }
                }
            }
            return pen;
        }

    }
	/*
Shaman
Cost Name
1 Lightning Bolt x 2 !
1 Rockbiter Weapon x 2 !!
1 Tunnel Trogg x 2 !!
2 Ancestral Knowledge x 1 !
2 Eternal Sentinel x 2 !
2 Flametongue Totem x 2 !
2 Totem Golem x 2 !
3 Feral Spirit x 2 !
3 Lava Burst x 2 !!
3 Tuskarr Totemic x 1 !
4 Flamewreathed Faceless x 2 !!
5 Doomhammer x 2 !!
Neutral Cards (8)
1 Abusive Sergeant x 2 !
1 Argent Squire x 1
1 Sir Finley Mrrgglton x 1
2 Flame Juggler x 2
3 Argent Horserider x 2
	*/

}